"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = require("react");
var _Meteor = _interopRequireDefault(require("../Meteor"));
var _lodash = require("lodash");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/**
 * @author Piotr Falba
 * @author Wei Zhuo
 * @author Jakub Kania
 * @author Nyby
 */

function depsFromValuesOf(params) {
  if ((0, _lodash.isObject)(params)) {
    return Object.values(params);
  }
  if (Array.isArray(params)) {
    return params;
  }
  return typeof params === 'undefined' ? [] : [params];
}
var _default = function _default(name) {
  var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var dependencies = arguments.length > 2 ? arguments[2] : undefined;
  var deps = dependencies || [_Meteor.default.userId(), ...depsFromValuesOf(args)];
  var [state, setState] = (0, _react.useState)({
    result: null,
    loading: true
  });
  var allArgsSet = !Object.values(args).some(x => x === undefined);
  (0, _react.useEffect)(() => {
    var mounted = true;
    if (!allArgsSet) {
      setState({
        result: null,
        loading: false
      });
    } else {
      _Meteor.default.call(name, args, (err, result) => {
        if (err) {
          console.log(err);
        }
        if (mounted) {
          setState({
            err,
            result,
            loading: false
          });
        }
      });
      setState({
        loading: true
      });
    }
    return () => {
      mounted = false;
    };
  }, deps);
  return state;
};
exports.default = _default;